# -*- coding: cp1251 -*-
# This is a test/3D visualization program for the Pololu MinIMU-9 + Arduino
# AHRS, based on "Test for Razor 9DOF IMU" by Jose Julio, copyright 2009.

# This script needs VPython, pyserial and pywin modules

# First Install Python 2.6.4 (Python 2.7 also works)
# Install pywin from http://sourceforge.net/projects/pywin32/
# Install pyserial from http://sourceforge.net/projects/pyserial/files/
# Install VPython from http://vpython.org/contents/download_windows.html
# -*- coding: cp1251 -*-

from Tkinter import *
from visual import *
import serial
import string
import math

from time import time

grad2rad = 3.141592/180.0

# Check your COM port and baud rate
#ser = serial.Serial(port='COM19',baudrate=115200, timeout=1) #F3Discovery-1
ser = serial.Serial(port='COM3',baudrate=57600, timeout=1) #CP21x
#ser = serial.Serial(port='COM14',baudrate=57600, timeout=1) #3DR
#ser = serial.Serial(port='COM14',baudrate=57600, timeout=1) #BT
#ser = serial.Serial(port='COM6',baudrate=115200, timeout=1) #F4Discovery


tmode = "a"
# uprava
root = Tk()
butClb = Button(root)
butStr = Button(root)
butOn = Button(root)
butOff = Button(root)

# Main scene
scene=display(title="")
scene.range=(1.2,1.2,1.2)
#scene.forward = (0,-1,-0.25)
scene.forward = (1,1,-0.25)
scene.up=(0,0,1)

# ustavka
scene3=display(title="")
scene3.range=(1.2,1.2,1.2)
#scene.forward = (0,-1,-0.25)
scene3.forward = (1,1,-0.25)
scene3.up=(0,0,1)
scene3.width=500
scene3.x=500
scene3.y=200

# Second scene (Roll, Pitch, Yaw)
scene2 = display(title='',x=0, y=0, width=500, height=200,center=(0,0,0), background=(0,0,0))
scene2.range=(1,1,1)
scene.width=500
scene.y=200

# vector scene (S, Vins, Err)
scene4 = display(title='',x=500, y=0, width=500, height=200,center=(0,0,0), background=(0,0,0))
scene4.range=(1,1,1)
scene4.width=500



# vector scene objects
scene4.select()
####################################################################################################################
# Reference axis (x,y,z)
#arrow(color=color.green,axis=(1,0,0), shaftwidth=0.02, fixedwidth=1)
#arrow(color=color.green,axis=(0,-1,0), shaftwidth=0.02 , fixedwidth=1)
#arrow(color=color.green,axis=(0,0,1), shaftwidth=0.02, fixedwidth=1)
# labels

label(pos=(-0.8,0.3,0),text="G",box=0,opacity=0,color=color.white)
l3gx = label(pos=(-0.8,0.2,0),text="Tekusch",box=0,opacity=0,color=color.white)
l3gy = label(pos=(-0.8,0.1,0),text="Tekusch",box=0,opacity=0,color=color.white)
l3gz = label(pos=(-0.8,0,0),text="Tekusch",box=0,opacity=0,color=color.white)

label(pos=(-0.6,0.3,0),text="Vins",box=0,opacity=0,color=color.blue)
l3ax = label(pos=(-0.6,0.2,0),text="X",box=0,opacity=0,color=color.blue)
l3ay = label(pos=(-0.6,0.1,0),text="X",box=0,opacity=0,color=color.blue)
l3az = label(pos=(-0.6,0,0),text="X",box=0,opacity=0,color=color.blue)

label(pos=(-0.4,0.3,0),text="Azimut",box=0,opacity=0,color=color.red)
l3mx = label(pos=(-0.4,0.2,0),text="Y",box=0,opacity=0,color=color.red)
l3my = label(pos=(-0.4,0.1,0),text="Y",box=0,opacity=0,color=color.red)
l3mz = label(pos=(-0.4,0,0),text="Y",box=0,opacity=0,color=color.red)

label(pos=(-0.2,0.3, 0),text="Err",box=0,opacity=0,color=color.yellow)
l3ex = label(pos=(-0.2,0.2, 0),text="Z",box=0,opacity=0,color=color.yellow)
l3ey = label(pos=(-0.2,0.1, 0),text="Z",box=0,opacity=0,color=color.yellow)
l3ez = label(pos=(-0.2,0,0),text="Z",box=0,opacity=0,color=color.yellow)


# IMU object
#platform = box(length=1, height=0.05, width=1, color=color.blue)
#p_line = box(length=1,height=0.08,width=0.1,color=color.yellow)
#plat_arrow = arrow(color=color.green,axis=(1,0,0), shaftwidth=0.06, fixedwidth=1)
#vG = arrow(color=color.white,axis=(0,0,-1), shaftwidth=0.08, fixedwidth=1)
#vMag = arrow(color=color.red,axis=(1,0,0), shaftwidth=0.08, fixedwidth=1)
#lMag = label(pos=(1,0, 0),text="Azimut",box=0,opacity=0)
#LG = label(pos=(0,0, 1),text="Acc",box=0,opacity=0)
###############################################################################################################

scene2.select()
#Roll, Pitch, Yaw
cil_roll = cylinder(pos=(-0.4,0,0),axis=(0.2,0,0),radius=0.01,color=color.red)
cil_roll2 = cylinder(pos=(-0.4,0,0),axis=(-0.2,0,0),radius=0.01,color=color.red)
cil_pitch = cylinder(pos=(0.1,0,0),axis=(0.2,0,0),radius=0.01,color=color.green)
cil_pitch2 = cylinder(pos=(0.1,0,0),axis=(-0.2,0,0),radius=0.01,color=color.green)
#cil_course = cylinder(pos=(0.6,0,0),axis=(0.2,0,0),radius=0.01,color=color.blue)
#cil_course2 = cylinder(pos=(0.6,0,0),axis=(-0.2,0,0),radius=0.01,color=color.blue)
arrow_course = arrow(pos=(0.6,0,0),color=color.cyan,axis=(-0.2,0,0), shaftwidth=0.02, fixedwidth=1)

#Roll,Pitch,Yaw labels
label(pos=(-0.4,0.3,0),text="Roll",box=0,opacity=0)
label(pos=(0.1,0.3,0),text="Pitch",box=0,opacity=0)
label(pos=(0.55,0.3,0),text="Yaw",box=0,opacity=0)
label(pos=(0.6,0.22,0),text="N",box=0,opacity=0,color=color.yellow)
label(pos=(0.6,-0.22,0),text="S",box=0,opacity=0,color=color.yellow)
label(pos=(0.38,0,0),text="W",box=0,opacity=0,color=color.yellow)
label(pos=(0.82,0,0),text="E",box=0,opacity=0,color=color.yellow)
label(pos=(0.75,0.15,0),height=7,text="NE",box=0,color=color.yellow)
label(pos=(0.45,0.15,0),height=7,text="NW",box=0,color=color.yellow)
label(pos=(0.75,-0.15,0),height=7,text="SE",box=0,color=color.yellow)
label(pos=(0.45,-0.15,0),height=7,text="SW",box=0,color=color.yellow)

L1 = label(pos=(-0.4,0.22,0),text="-",box=0,opacity=0)
L2 = label(pos=(0.1,0.22,0),text="-",box=0,opacity=0)
L3 = label(pos=(0.7,0.3,0),text="-",box=0,opacity=0)

# Main scene objects
scene.select()
# Reference axis (x,y,z)
arrow(color=color.green,axis=(1,0,0), shaftwidth=0.02, fixedwidth=1)
arrow(color=color.green,axis=(0,-1,0), shaftwidth=0.02 , fixedwidth=1)
arrow(color=color.green,axis=(0,0,1), shaftwidth=0.02, fixedwidth=1)
# labels
label(pos=(0,0,0.8),text="Tekusch",box=0,opacity=0)
label(pos=(1,0,0),text="X",box=0,opacity=0)
label(pos=(0,-1,0),text="Y",box=0,opacity=0)
label(pos=(0,0, 1),text="Z",box=0,opacity=0)
# IMU object
platform = box(length=1, height=0.05, width=1, color=color.blue)
p_line = box(length=1,height=0.08,width=0.1,color=color.yellow)
plat_arrow = arrow(color=color.green,axis=(1,0,0), shaftwidth=0.06, fixedwidth=1)
vG = arrow(color=color.white,axis=(0,0,-1), shaftwidth=0.08, fixedwidth=1)
vMag = arrow(color=color.red,axis=(1,0,0), shaftwidth=0.08, fixedwidth=1)
lMag = label(pos=(1,0, 0),text="Azimut",box=0,opacity=0)
LG = label(pos=(0,0, 1),text="Acc",box=0,opacity=0)

# ustavka !!!!!!!!!!!!!!!!!!!!!!1
scene3.select()
# Reference axis (x,y,z)
arrow(color=color.green,axis=(1,0,0), shaftwidth=0.02, fixedwidth=1)
arrow(color=color.green,axis=(0,-1,0), shaftwidth=0.02 , fixedwidth=1)
arrow(color=color.green,axis=(0,0,1), shaftwidth=0.02, fixedwidth=1)
# labels
label(pos=(0,0,0.8),text="Ustavka",box=0,opacity=0)
label(pos=(1,0,0),text="X",box=0,opacity=0)
label(pos=(0,-1,0),text="Y",box=0,opacity=0)
label(pos=(0,0,1),text="Z",box=0,opacity=0)
# IMU object
platform3 = box(length=1, height=0.05, width=1, color=color.red)
p_line3 = box(length=1,height=0.08,width=0.1,color=color.yellow)
plat_arrow3 = arrow(color=color.green,axis=(1,0,0), shaftwidth=0.06, fixedwidth=1)
vV = arrow(color=color.blue,axis=(0,0,0), shaftwidth=0.08, fixedwidth=1)
lV = label(pos=(0,0, 0),text="Vins",box=0,opacity=0)
vP = arrow(color=color.yellow,axis=(1,-1,1), shaftwidth=0.08, fixedwidth=1)
lP = label(pos=(0,0, 0),text="Prob",box=0,opacity=0)

#f = open("Serial"+str(time())+".txt", 'w')

# dostuchatsa do INS 
line = ser.readline()
while line.find(">") == -1:
        ser.write(chr(13))
        line = ser.readline()
#  kalibrovka 
ser.write("c")


roll=0
pitch=0
yaw=0
num = 0
while 1:               
    line = ser.readline()    
#proverka svyazi
    num = 0
    while len(line) < 2 and num < 10:
            ser.write(chr(8))
            ser.write(chr(8))
            ser.write(chr(13))
            line = ser.readline()
            num = num + 1
            print "  - ", num
    if num == 10:
            ser.close()
            print " ..."
            ser.open()
            print " ..."                    

    if line.find("!ANG:") != -1:          # filter out incomplete (invalid) lines
        line = line.replace("!ANG:","")   # Delete "!ANG:"
        print line
        #f.write(line)                     # Write to the output log file
        words = string.split(line,",")    # Fields split
        if len(words) > 2:
            try:
                roll = float(words[0])*grad2rad
                pitch = float(words[1])*grad2rad
                yaw = float(words[2])*grad2rad
            except:
                print " "
                
            try:
                roll3 = float(words[3])*grad2rad
                pitch3 = float(words[4])*grad2rad
                yaw3 = float(words[5])*grad2rad
            except:
                roll3 = roll
                pitch3 = pitch
                yaw3 = yaw

            # vector G
            try:                    
                Gx = float(words[6])
                Gy = -float(words[7])
                Gz = float(words[8])

                l3gx.text = str(Gx)
                l3gy.text = str(-Gy)
                l3gz.text = str(Gz)
                
                mG= sqrt(Gx*Gx + Gy*Gy + Gz*Gz)
                if (mG> 10):
                        Gx = Gx/mG*10
                        Gy = Gy/mG*10
                        Gz = Gz/mG*10                
                
            except:
                Gx = 0
                Gy = 0
                Gz = 0
                
            # vector Vmag
            try:                    
                vMx = float(words[9])
                vMy = -float(words[10])
                vMz = float(words[11])

                l3mx.text = str(vMx)
                l3my.text = str(-vMy)
                l3mz.text = str(vMz)
                
                mV= sqrt(vMx*vMx + vMy*vMy + vMz*vMz)
                if (mV> 10):
                        vMx = vMx/mV*10
                        vMy = vMy/mV*10
                        vMz = vMz/mV*10
            except:
                vMx = 0
                vMy = 0
                vMz =0
                
            # vector V2
            try:                    
                Vx = float(words[12])
                Vy = -float(words[13])
                Vz = float(words[14])

                l3ax.text = str(Vx)
                l3ay.text = str(-Vy)
                l3az.text = str(Vz)
                
                mV= sqrt(Vx*Vx + Vy*Vy + Vz*Vz)
                if (mV> 10):
                        Vx = Vx/mV*10
                        Vy = Vy/mV*10
                        Vz = Vz/mV*10
                        
            except:
                Vx = 0
                Vy = 0
                Vz =0


            # vector V3
            try:                    
                pVx = float(words[15])
                pVy = -float(words[16])
                pVz = float(words[17])

                l3ex.text = str(pVx)
                l3ey.text = str(-pVy)
                l3ez.text = str(pVz)

                mV= sqrt(pVx*pVx + pVy*pVy + pVz*pVz)
                if (mV> 10):
                        pVx = pVx/mV*10
                        pVy = pVy/mV*10
                        pVz = pVz/mV*10
                        
            except:
                pVx = 1
                pVy = -1
                pVz = 1
                
            axis=(cos(pitch)*cos(yaw),-cos(pitch)*sin(yaw),sin(pitch)) 
            up=(sin(roll)*sin(yaw)+cos(roll)*sin(pitch)*cos(yaw),sin(roll)*cos(yaw)-cos(roll)*sin(pitch)*sin(yaw),-cos(roll)*cos(pitch))
            platform.axis=axis
            platform.up=up
            platform.length=0.65
            platform.width=1.2
            plat_arrow.axis=axis
            plat_arrow.up=up
            plat_arrow.length=0.8

           
            vG.axis=(Gx,Gy,Gz)                      
            LG.pos = (Gx,Gy,Gz)
            
            vV.axis = (Vx,Vy,Vz)
            lV.pos = (Vx,Vy,Vz)
            
            vMag.axis = (vMx,vMy,vMz)
            lMag.pos = (vMx,vMy,vMz)
            #vV.text = "V="+sqrt(Vx*Vx+Vy*Vy+Vz*Vz)

            vP.axis = (pVx,pVy,pVz)
            lP.pos = (pVx,pVy,pVz) 
            
            p_line.axis=axis
            p_line.up=up
            cil_roll.axis=(0.2*cos(roll),0.2*sin(roll),0)
            cil_roll2.axis=(-0.2*cos(roll),-0.2*sin(roll),0)
            cil_pitch.axis=(0.2*cos(pitch),0.2*sin(pitch),0)
            cil_pitch2.axis=(-0.2*cos(pitch),-0.2*sin(pitch),0)
            arrow_course.axis=(0.2*sin(yaw),0.2*cos(yaw),0)
            try:
                    L1.text = str(float(words[0]))
                    L2.text = str(float(words[1]))
                    L3.text = str(float(words[2]))
            except:
                    "  "

            
            axis=(cos(pitch3)*cos(yaw3),-cos(pitch3)*sin(yaw3),sin(pitch3)) 
            up=(sin(roll3)*sin(yaw3)+cos(roll3)*sin(pitch3)*cos(yaw3),sin(roll3)*cos(yaw3)-cos(roll3)*sin(pitch3)*sin(yaw3),-cos(roll3)*cos(pitch3))
            platform3.axis=axis
            platform3.up=up
            platform3.length=0.65
            platform3.width=1.2
            plat_arrow3.axis=axis
            plat_arrow3.up=up
            plat_arrow3.length=0.8
            p_line3.axis=axis
            p_line3.up=up
    else:
            # dostuchatsa do INS
            line = ser.readline()
            num = 0
            while line.find(">") == -1 and num < 6:
                    ser.write(chr(8))
                    ser.write(chr(8))
                    ser.write(chr(13))
                    line = ser.readline()
                    num = num + 1
                    print "  IMU -",num   
        
            # vibor rezhima
            num = 0
            while line.find("!ANG:") == -1 and num < 6:
                    ser.write(tmode)
                    line = ser.readline()
                    num = num + 1
                    print "  ANG - ", num
root.mainloop()
ser.close
#f.close

